
SUBROUTINE fcnc (NN, x, fvec, arpno, IBDSn, reln, eps, IinvU, familyn, n, t, m, varp, typeno, kind)
           
  IMPLICIT NONE
  integer, parameter      :: DP = selected_real_kind(33)
  INTEGER, INTENT(IN)     :: NN, m, arpno,  reln(arpno)
  INTEGER, INTENT(IN)     :: familyn(arpno), kind
  INTEGER, INTENT(IN)     :: n, typeno(kind)
  INTEGER                 :: i,j,k

  

  REAL(KIND=DP), INTENT(IN)        :: IBDSn(m,arpno)
  REAL(KIND=DP), INTENT(IN)        :: x(NN)
  REAL(KIND=DP), INTENT(OUT)       :: fvec(NN)
  REAL(KIND=DP)           :: mu(m,arpno), t(m), dev(NN,m,arpno) ! dev is the transpose of the derivative matrix
  REAL(KIND=DP)           :: res(m,1,arpno), scoreid(NN,1,arpno)
  REAL(KIND=DP)           :: Mean(m), Empvar(m,m), Empvarinv(m,m), prescoreid(NN,m,arpno)
  REAL(KIND=DP)           :: Infoid(NN,NN,arpno)
  REAL(KIND=DP)           :: Info(NN,NN), Infoinv(NN,NN)
  REAL(KIND=DP)           :: devt(m,NN,arpno)
  REAL(KIND=DP), INTENT(IN):: eps
  REAL(KIND=DP)           :: scorep(NN,1,n), scorept(1,NN,n), Infop(NN,NN,n)
  REAL(KIND=DP)           :: Infor(NN,NN), prevar(NN,NN)
  REAL(KIND=DP), INTENT(OUT):: varp(NN,NN)
  REAL(KIND=DP)           :: d, d1, d2, d3, p1, p2, dp1, dp2
  REAL(KIND=DP)           :: p11, p12, p13
  REAL(KIND=DP)           :: p21, p22
  REAL(KIND=DP)           :: p11d1, p12d2, p13d1, p13d2
  REAL(KIND=DP)           :: p21d2, p22d1
  REAL(KIND=DP), INTENT(OUT)  :: IinvU(NN)
  REAL(KIND=DP)           :: f
  REAL(KIND=DP)           :: fc1, fc2    ! Functions to map C to lambda
  REAL(KIND=DP)           :: dfc1, dfc2  ! Derivatives of fc


  ! d1=t(k)-x(1)
  ! d2=x(2)-t(k)
  ! d3=x(2)-x(1)  if in the third interval (the most complicated interval)


  ! Construct the marker map
  


  dev=0.0_dp
  fvec=0.0_dp
  mu=0.0_dp
  d1=0.0_dp
  d2=0.0_dp
  d3=0.0_dp
  d=0.0_dp
  f=0.0_dp

 


  DO i=1, arpno
    SELECT CASE(reln(i))
      CASE (1)   ! full-sib
        fc1=(x(3)-1.0_dp)/(2.0_dp*x(3))
        dfc1=1.0_dp/(2.0_dp*x(3)**2)
        fc2=(x(4)-1.0_dp)/(2.0_dp*x(4))
        dfc2=1.0_dp/(2.0_dp*x(4)**2)
        DO k=1, m

          IF ( t(k)-x(1)<eps ) THEN              ! Interval I
            IF ( t(k)-x(1)<-eps ) THEN
              d=x(1)-t(k)
              f=1.0_dp
            ELSE 
              d=((x(1)-t(k))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(1))/eps
            END IF    
            mu(k,i)=1.0_dp+exp(-4.0_dp*d)*fc1

            dev(1,k,i)=-4.0_dp*fc1*exp(-4.0_dp*d)*f
            dev(3,k,i)=exp(-4.0_dp*d)*dfc1


          ELSE IF ( t(k)-x(2)>-eps ) THEN        ! Interval II
            IF ( t(k)-x(2)>eps ) THEN
              d=t(k)-x(2)
              f=-1.0_dp
            ELSE
              d=((t(k)-x(2))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(2))/eps
            END IF
            mu(k,i)=1.0_dp+exp(-4.0_dp*d)*fc2

            dev(2,k,i)=-4.0_dp*fc2*exp(-4.0_dp*d)*f
            dev(4,k,i)=exp(-4.0_dp*d)*dfc2


          ELSE                                   ! Interval III, the most complicated case

            d1=t(k)-x(1)
            d2=x(2)-t(k)
            d3=x(2)-x(1)

            p11=exp(-4.0_dp*d1)
            p11d1=4.0_dp*exp(-4.0_dp*d1)
            p12=1.0_dp-exp(-8.0_dp*d2)
            p12d2=8.0_dp*exp(-8.0_dp*d2)
            p13=1.0_dp-exp(-8.0_dp*d3)
            p13d1=-8.0_dp*exp(-8.0_dp*d3)
            p13d2=8.0_dp*exp(-8.0_dp*d3)

            p21=exp(-4.0_dp*d2)
            p21d2=-4.0_dp*exp(-4.0_dp*d2)
            p22=1.0_dp-exp(-8.0_dp*d1)
            p22d1=-8.0_dp*exp(-8.0_dp*d1)

            p1=p11*p12*fc1/p13
            p2=p21*p22*fc2/p13

            mu(k,i)=1.0_dp+p1+p2

            dp1=((p11d1*p13-p11*p13d1)*p12*fc1)/(p13**2)
            dp2=((p22d1*p13-p22*p13d1)*p21*fc2)/(p13**2)

	    dev(1,k,i)=dp1+dp2

            dp1=((p12d2*p13-p12*p13d2)*p11*fc1)/(p13**2)
            dp2=((p21d2*p13-p21*p13d2)*p22*fc2)/(p13**2)
    
            dev(2,k,i)=dp1+dp2
 
	    dev(3,k,i)=((p11*p12)/p13)*dfc1  
	    dev(4,k,i)=((p21*p22)/p13)*dfc2
          END IF
        END DO


      CASE (2)   ! half-sib
        fc1=(x(3)-1.0_dp)/(2.0_dp*x(3)+2.0_dp)
        dfc1=1.0_dp/(x(3)+1.0_dp)**2
        fc2=(x(4)-1.0_dp)/(2.0_dp*x(4)+2.0_dp)
        dfc2=1.0_dp/(x(4)+1.0_dp)**2
        DO k=1, m

          IF ( t(k)-x(1)<eps ) THEN              ! Interval I
            IF ( t(k)-x(1)<-eps ) THEN
              d=x(1)-t(k)
              f=1.0_dp
            ELSE 
              d=((x(1)-t(k))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(1))/eps
            END IF    
            mu(k,i)=0.5_dp+exp(-4.0_dp*d)*fc1

            dev(1,k,i)=-4.0_dp*fc1*exp(-4.0_dp*d)*f
            dev(3,k,i)=exp(-4.0_dp*d)*dfc1


          ELSE IF ( t(k)-x(2)>-eps ) THEN        ! Interval II
            IF ( t(k)-x(2)>eps ) THEN
              d=t(k)-x(2)
              f=-1.0_dp
            ELSE
              d=((t(k)-x(2))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(2))/eps
            END IF
            mu(k,i)=0.5_dp+exp(-4.0_dp*d)*fc2

            dev(2,k,i)=-4.0_dp*fc2*exp(-4.0_dp*d)*f
            dev(4,k,i)=exp(-4.0_dp*d)*dfc2


          ELSE                                   ! Interval III, the most complicated case

            d1=t(k)-x(1)
            d2=x(2)-t(k)
            d3=x(2)-x(1)

            p11=exp(-4.0_dp*d1)
            p11d1=4.0_dp*exp(-4.0_dp*d1)
            p12=1.0_dp-exp(-8.0_dp*d2)
            p12d2=8.0_dp*exp(-8.0_dp*d2)
            p13=1.0_dp-exp(-8.0_dp*d3)
            p13d1=-8.0_dp*exp(-8.0_dp*d3)
            p13d2=8.0_dp*exp(-8.0_dp*d3)

            p21=exp(-4.0_dp*d2)
            p21d2=-4.0_dp*exp(-4.0_dp*d2)
            p22=1.0_dp-exp(-8.0_dp*d1)
            p22d1=-8.0_dp*exp(-8.0_dp*d1)

            p1=p11*p12*fc1/p13
            p2=p21*p22*fc2/p13

            mu(k,i)=0.5_dp+p1+p2

            dp1=((p11d1*p13-p11*p13d1)*p12*fc1)/(p13**2)
            dp2=((p22d1*p13-p22*p13d1)*p21*fc2)/(p13**2)

	    dev(1,k,i)=dp1+dp2

            dp1=((p12d2*p13-p12*p13d2)*p11*fc1)/(p13**2)
            dp2=((p21d2*p13-p21*p13d2)*p22*fc2)/(p13**2)
    
            dev(2,k,i)=dp1+dp2
 
	    dev(3,k,i)=((p11*p12)/p13)*dfc1  
	    dev(4,k,i)=((p21*p22)/p13)*dfc2
          END IF
        END DO



      CASE (3)   ! first cousins
        fc1=(3.0_dp*x(3)-3.0_dp)/(4.0_dp*x(3)+12.0_dp)
        dfc1=3.0_dp/(x(3)+3.0_dp)**2
        fc2=(3.0_dp*x(4)-3.0_dp)/(4.0_dp*x(4)+12.0_dp)
        dfc2=3.0_dp/(x(4)+3.0_dp)**2
        DO k=1, m
          IF ( t(k)-x(1)<eps ) THEN              ! Interval I
            IF ( t(k)-x(1)<-eps ) THEN
              d=x(1)-t(k)
              f=1.0_dp
            ELSE 
              d=((x(1)-t(k))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(1))/eps
            END IF   
            mu(k,i)=0.25_dp+(0.5_dp*exp(-4.0_dp*d)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d))*fc1
	    dev(1,k,i)=(-2.0_dp*fc1*exp(-4.0_dp*d)-2.0_dp*fc1*exp(-6.0_dp*d)-(8.0_dp/6.0_dp)*fc1*exp(-8.0_dp*d))*f
	    dev(3,k,i)=(0.5_dp*exp(-4.0_dp*d)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d))*dfc1

          ELSE IF ( t(k)-x(2)>-eps ) THEN        ! Interval II
            IF ( t(k)-x(2)>eps ) THEN
              d=t(k)-x(2)
              f=-1.0_dp
            ELSE
              d=((t(k)-x(2))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(2))/eps
            END IF
            mu(k,i)=0.25_dp+(0.5_dp*exp(-4.0_dp*d)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d))*fc2
	    dev(2,k,i)=(-2.0_dp*fc2*exp(-4.0_dp*d)-2.0_dp*fc2*exp(-6.0_dp*d)-(8.0_dp/6.0_dp)*fc2*exp(-8.0_dp*d))*f	   
	    dev(4,k,i)=(0.5_dp*exp(-4.0_dp*d)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d))*dfc2

          ELSE                            ! Interval III, the most complicated case

            d1=t(k)-x(1)
            d2=x(2)-t(k)
            d3=x(2)-x(1)

            p11=0.5_dp*exp(-4.0_dp*d1)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d1)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d1)
            p11d1=0.5_dp*exp(-4.0_dp*d1)*4.0_dp+(1.0_dp/3.0_dp)*exp(-6.0_dp*d1)*6.0_dp+(1.0_dp/6.0_dp)*exp(-8.0_dp*d1)*8.0_dp
            p12=1.0_dp-(0.5_dp*exp(-4.0_dp*d2)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d2)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d2))**2
            p12d2=-2.0_dp*(0.5_dp*exp(-4.0_dp*d2)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d2)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d2))*  &
                 &   (0.5_dp*exp(-4.0_dp*d2)*(-4.0_dp)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d2)*(-6.0_dp)+(1.0_dp/6.0_dp)*  &
                 &   exp(-8.0_dp*d2)*(-8.0_dp))
            p13=1.0_dp-(0.5_dp*exp(-4.0_dp*d3)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d3)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d3))**2
            p13d1=-2.0_dp*(0.5_dp*exp(-4.0_dp*d3)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d3)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d3))*  &
                 &   (0.5_dp*exp(-4.0_dp*d3)*(4.0_dp)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d3)*(6.0_dp)+(1.0_dp/6.0_dp)*  &
                 &   exp(-8.0_dp*d3)*(8.0_dp))
            p13d2=-2.0_dp*(0.5_dp*exp(-4.0_dp*d3)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d3)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d3))*  &
                 &   (0.5_dp*exp(-4.0_dp*d3)*(-4.0_dp)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d3)*(-6.0_dp)+(1.0_dp/6.0_dp)*  &
                 &   exp(-8.0_dp*d3)*(-8.0_dp))


            p21=0.5_dp*exp(-4.0_dp*d2)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d2)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d2)
            p21d2=0.5_dp*exp(-4.0_dp*d2)*(-4.0_dp)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d2)*(-6.0_dp)+(1.0_dp/6.0_dp)  &
                 &   *exp(-8.0_dp*d2)*(-8.0_dp)
            p22=1.0_dp-(0.5_dp*exp(-4.0_dp*d1)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d1)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d1))**2
            p22d1=-2.0_dp*(0.5_dp*exp(-4.0_dp*d1)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d1)+(1.0_dp/6.0_dp)*exp(-8.0_dp*d1))*  &
                 &   (0.5_dp*exp(-4.0_dp*d1)*(4.0_dp)+(1.0_dp/3.0_dp)*exp(-6.0_dp*d1)*(6.0_dp)+(1.0_dp/6.0_dp)*  &
                 &   exp(-8.0_dp*d1)*(8.0_dp))
      

            p1=p11*p12*fc1/p13
            p2=p21*p22*fc2/p13

            mu(k,i)=0.25_dp+p1+p2

            dp1=((p11d1*p13-p11*p13d1)*p12*fc1)/(p13**2)
            dp2=((p22d1*p13-p22*p13d1)*p21*fc2)/(p13**2)

	    dev(1,k,i)=dp1+dp2

            dp1=((p12d2*p13-p12*p13d2)*p11*fc1)/(p13**2)
            dp2=((p21d2*p13-p21*p13d2)*p22*fc2)/(p13**2)
    
            dev(2,k,i)=dp1+dp2
 
	    dev(3,k,i)=((p11*p12)/p13)*dfc1  
	    dev(4,k,i)=((p21*p22)/p13)*dfc2

          END IF
        END DO


      CASE (4)   ! grandparent-grandchild
        fc1=(x(3)-1.0_dp)/(2.0_dp*x(3)+2.0_dp)
        dfc1=1.0_dp/(x(3)+1.0_dp)**2
        fc2=(x(4)-1.0_dp)/(2.0_dp*x(4)+2.0_dp)
        dfc2=1.0_dp/(x(4)+1.0_dp)**2
        DO k=1, m

          IF ( t(k)-x(1)<eps ) THEN              ! Interval I
            IF ( t(k)-x(1)<-eps ) THEN
              d=x(1)-t(k)
              f=1.0_dp
            ELSE 
              d=((x(1)-t(k))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(1))/eps
            END IF    
            mu(k,i)=0.5_dp+exp(-2.0_dp*d)*fc1

            dev(1,k,i)=-2.0_dp*fc1*exp(-2.0_dp*d)*f
            dev(3,k,i)=exp(-2.0_dp*d)*dfc1


          ELSE IF ( t(k)-x(2)>-eps ) THEN        ! Interval II
            IF ( t(k)-x(2)>eps ) THEN
              d=t(k)-x(2)
              f=-1.0_dp
            ELSE
              d=((t(k)-x(2))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(2))/eps
            END IF
            mu(k,i)=0.5_dp+exp(-2.0_dp*d)*fc2

            dev(2,k,i)=-2.0_dp*fc2*exp(-2.0_dp*d)*f
            dev(4,k,i)=exp(-2.0_dp*d)*dfc2


          ELSE                                   ! Interval III, the most complicated case

            d1=t(k)-x(1)
            d2=x(2)-t(k)
            d3=x(2)-x(1)

            p11=exp(-2.0_dp*d1)
            p11d1=2.0_dp*exp(-2.0_dp*d1)
            p12=1.0_dp-exp(-4.0_dp*d2)
            p12d2=4.0_dp*exp(-4.0_dp*d2)
            p13=1.0_dp-exp(-4.0_dp*d3)
            p13d1=-4.0_dp*exp(-4.0_dp*d3)
            p13d2=4.0_dp*exp(-4.0_dp*d3)

            p21=exp(-2.0_dp*d2)
            p21d2=-2.0_dp*exp(-2.0_dp*d2)
            p22=1.0_dp-exp(-4.0_dp*d1)
            p22d1=-4.0_dp*exp(-4.0_dp*d1)

            p1=p11*p12*fc1/p13
            p2=p21*p22*fc2/p13

            mu(k,i)=0.5_dp+p1+p2

            dp1=((p11d1*p13-p11*p13d1)*p12*fc1)/(p13**2)
            dp2=((p22d1*p13-p22*p13d1)*p21*fc2)/(p13**2)

	    dev(1,k,i)=dp1+dp2

            dp1=((p12d2*p13-p12*p13d2)*p11*fc1)/(p13**2)
            dp2=((p21d2*p13-p21*p13d2)*p22*fc2)/(p13**2)
    
            dev(2,k,i)=dp1+dp2
 
	    dev(3,k,i)=((p11*p12)/p13)*dfc1  
	    dev(4,k,i)=((p21*p22)/p13)*dfc2
          END IF
        END DO



      CASE (5)   ! avuncular pairs

        fc1=(x(3)-1.0_dp)/(2.0_dp*x(3)+2.0_dp)
        dfc1=1.0_dp/(x(3)+1.0_dp)**2
        fc2=(x(4)-1.0_dp)/(2.0_dp*x(4)+2.0_dp)
        dfc2=1.0_dp/(x(4)+1.0_dp)**2
        DO k=1, m
          IF ( t(k)-x(1)<eps ) THEN              ! Interval I
            IF ( t(k)-x(1)<-eps ) THEN
              d=x(1)-t(k)
              f=1.0_dp
            ELSE 
              d=((x(1)-t(k))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(1))/eps
            END IF   
            mu(k,i)=0.5_dp+(0.5_dp*exp(-4.0_dp*d)+0.5_dp*exp(-6.0_dp*d))*fc1
	    dev(1,k,i)=(-2.0_dp*fc1*exp(-4.0_dp*d)-3.0_dp*fc1*exp(-6.0_dp*d))*f
	    dev(3,k,i)=(0.5_dp*exp(-4.0_dp*d)+0.5_dp*exp(-6.0_dp*d))*dfc1

          ELSE IF ( t(k)-x(2)>-eps ) THEN        ! Interval II
            IF ( t(k)-x(2)>eps ) THEN
              d=t(k)-x(2)
              f=-1.0_dp
            ELSE
              d=((t(k)-x(2))**2)/(2.0_dp*eps)+0.5_dp*eps
              f=-(t(k)-x(2))/eps
            END IF
            mu(k,i)=0.5_dp+(0.5_dp*exp(-4.0_dp*d)+0.5_dp*exp(-6.0_dp*d))*fc2
	    dev(2,k,i)=(-2.0_dp*fc2*exp(-4.0_dp*d)-3.0_dp*fc2*exp(-6.0_dp*d))*f
	    dev(4,k,i)=(0.5_dp*exp(-4.0_dp*d)+0.5_dp*exp(-6.0_dp*d))*dfc2

          ELSE                            ! Interval III, the most complicated case
            d1=t(k)-x(1)
            d2=x(2)-t(k)
            d3=x(2)-x(1)

            p11=0.5_dp*exp(-4.0_dp*d1)+0.5_dp*exp(-6.0_dp*d1)
            p11d1=0.5_dp*exp(-4.0_dp*d1)*4.0_dp+0.5_dp*exp(-6.0_dp*d1)*6.0_dp
            p12=1.0_dp-(0.5_dp*exp(-4.0_dp*d2)+0.5_dp*exp(-6.0_dp*d2))**2
            p12d2=-2.0_dp*(0.5_dp*exp(-4.0_dp*d2)+0.5_dp*exp(-6.0_dp*d2))*  &
                 &   (0.5_dp*exp(-4.0_dp*d2)*(-4.0_dp)+0.5_dp*exp(-6.0_dp*d2)*(-6.0_dp))
            p13=1.0_dp-(0.5_dp*exp(-4.0_dp*d3)+0.5_dp*exp(-6.0_dp*d3))**2
            p13d1=-2.0_dp*(0.5_dp*exp(-4.0_dp*d3)+0.5_dp*exp(-6.0_dp*d3))*  &
                 &   (0.5_dp*exp(-4.0_dp*d3)*(4.0_dp)+0.5_dp*exp(-6.0_dp*d3)*(6.0_dp))
            p13d2=-2.0_dp*(0.5_dp*exp(-4.0_dp*d3)+0.5_dp*exp(-6.0_dp*d3))*  &
                 &   (0.5_dp*exp(-4.0_dp*d3)*(-4.0_dp)+0.5_dp*exp(-6.0_dp*d3)*(-6.0_dp))


            p21=0.5_dp*exp(-4.0_dp*d2)+0.5_dp*exp(-6.0_dp*d2)
            p21d2=0.5_dp*exp(-4.0_dp*d2)*(-4.0_dp)+0.5_dp*exp(-6.0_dp*d2)*(-6.0_dp)
            p22=1.0_dp-(0.5_dp*exp(-4.0_dp*d1)+0.5_dp*exp(-6.0_dp*d1))**2
            p22d1=-2.0_dp*(0.5_dp*exp(-4.0_dp*d1)+0.5_dp*exp(-6.0_dp*d1))*  &
                 &   (0.5_dp*exp(-4.0_dp*d1)*(4.0_dp)+0.5_dp*exp(-6.0_dp*d1)*(6.0_dp))
      

            p1=p11*p12*fc1/p13
            p2=p21*p22*fc2/p13

            mu(k,i)=0.5_dp+p1+p2

            dp1=((p11d1*p13-p11*p13d1)*p12*fc1)/(p13**2)
            dp2=((p22d1*p13-p22*p13d1)*p21*fc2)/(p13**2)

	    dev(1,k,i)=dp1+dp2

            dp1=((p12d2*p13-p12*p13d2)*p11*fc1)/(p13**2)
            dp2=((p21d2*p13-p21*p13d2)*p22*fc2)/(p13**2)
    
            dev(2,k,i)=dp1+dp2
 
	    dev(3,k,i)=((p11*p12)/p13)*dfc1  
	    dev(4,k,i)=((p21*p22)/p13)*dfc2

          END IF
        END DO

    END SELECT
  END DO


  CALL Var(m, arpno, IBDSn, Empvar, Mean)
  
  Empvarinv=0.0_dp
  DO k=1, m
    Empvarinv(k,k)=1.0_dp/Empvar(k,k)
  END DO


  DO k=1, m
    DO i=1, NN
      DO j=1, arpno
        devt(k,i,j)=dev(i,k,j)
      END DO
    END DO
  END DO

  DO i=1, arpno
    DO k=1, m
      res(k,1,i)=IBDSn(k,i)-mu(k,i)
    END DO
  END DO

  prescoreid=0.0_dp
  scoreid=0.0_dp
  Infoid=0.0_dp
  Info=0.0_dp
  fvec=0.0_dp
  Infoinv=0.0_dp
  IinvU=0.0_dp   

  DO i=1, arpno
    prescoreid(1:NN,1:m,i)=MATMUL(dev(1:NN,1:m,i),Empvarinv(1:m,1:m))  
    scoreid(1:NN,1,i)=MATMUL(prescoreid(1:NN,1:m,i),res(1:m,1,i))  ! the score of the ith ARP
    Infoid(1:NN,1:NN,i)=MATMUL(prescoreid(1:NN,1:m,i),devt(1:m,1:NN,i))
  END DO

  scorep=0.0_dp
  scorept=0.0_dp
  Infop=0.0_dp

  
  DO i=1, n
    DO j=1, NN
      DO k=1, arpno
        IF ( familyn(k) .EQ. i ) THEN
          scorep(j,1,i)=scorep(j,1,i)+scoreid(j,1,k)
        END IF
      END DO
    END DO
  END DO

  DO i=1, n
    DO j=1, NN
      scorept(1,j,i)=scorep(j,1,i)
    END DO
  END DO

  DO i=1, n
    Infop(1:NN,1:NN,i)=MATMUL(scorep(1:NN,1:1,i),scorept(1:1,1:NN,i))
  END DO

  Info=0.0_dp
  Infor=0.0_dp


  DO i=1, NN
    DO k=1, NN
      IF (i .LE. k) THEN
        Info(i,k)=SUM(Infoid(i,k,1:arpno))
        Infor(i,k)=SUM(Infop(i,k,1:n))
      ELSE
        Info(i,k)=Info(k,i)
        Infor(i,k)=Infor(k,i)
      END IF
    END DO
  END DO

  DO i=1, NN
    fvec(i)=SUM(scoreid(i,1,1:arpno))  ! combine all the information from arpno ARPs
  END DO

  CALL GINV (Info, Infoinv, NN, NN)

  IinvU=MATMUL(Infoinv,fvec)

  prevar=MATMUL(Infoinv,Infor)
  varp=MATMUL(prevar,Infoinv)

 END SUBROUTINE fcnc

